//
//  TokenStakingOldCell.swift
//  Cosmostation
//
//  Created by 정용주 on 2021/08/20.
//  Copyright © 2021 wannabit. All rights reserved.
//

import UIKit

class TokenStakingOldCell: UITableViewCell {
    
    @IBOutlet weak var cardRoot: CardView!
    @IBOutlet weak var totalAmount: UILabel!
    @IBOutlet weak var availableAmount: UILabel!
    @IBOutlet weak var vestingLayer: UIView!
    @IBOutlet weak var vestingAmount: UILabel!
    @IBOutlet weak var delegatedLayer: UIView!
    @IBOutlet weak var delegatedAmount: UILabel!
    @IBOutlet weak var unbondingLayer: UIView!
    @IBOutlet weak var unbondingAmount: UILabel!
    @IBOutlet weak var rewardLayer: UIView!
    @IBOutlet weak var rewardAmount: UILabel!
    @IBOutlet weak var lockedLayer: UIView!
    @IBOutlet weak var lockedAmount: UILabel!
    @IBOutlet weak var frozenLayer: UIView!
    @IBOutlet weak var frozenAmount: UILabel!
    @IBOutlet weak var okStakingLayer: UIView!
    @IBOutlet weak var okStakingAmount: UILabel!
    @IBOutlet weak var okUnbondingLayer: UIView!
    @IBOutlet weak var okUnbondingAmount: UILabel!

    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        
        availableAmount.font = UIFontMetrics(forTextStyle: .footnote).scaledFont(for: Font_13_footnote)
        vestingAmount.font = UIFontMetrics(forTextStyle: .footnote).scaledFont(for: Font_13_footnote)
        delegatedAmount.font = UIFontMetrics(forTextStyle: .footnote).scaledFont(for: Font_13_footnote)
        unbondingAmount.font = UIFontMetrics(forTextStyle: .footnote).scaledFont(for: Font_13_footnote)
        rewardAmount.font = UIFontMetrics(forTextStyle: .footnote).scaledFont(for: Font_13_footnote)
        lockedAmount.font = UIFontMetrics(forTextStyle: .footnote).scaledFont(for: Font_13_footnote)
        frozenAmount.font = UIFontMetrics(forTextStyle: .footnote).scaledFont(for: Font_13_footnote)
        okStakingAmount.font = UIFontMetrics(forTextStyle: .footnote).scaledFont(for: Font_13_footnote)
        okUnbondingAmount.font = UIFontMetrics(forTextStyle: .footnote).scaledFont(for: Font_13_footnote)
        
    }
    
    func onBindStakingToken(_ chainType: ChainType) {
        let chainConfig = ChainFactory.getChainConfig(chainType)
        let stakingDenom = WUtils.getMainDenom(chainConfig)
        let stakingDivideDecimal = WUtils.mainDivideDecimal(chainType)
        let stakingDisplayDecimal = WUtils.mainDisplayDecimal(chainType)
        
        if (chainType == ChainType.BINANCE_MAIN) {
            vestingLayer.isHidden = true
            delegatedLayer.isHidden = true
            unbondingLayer.isHidden = true
            rewardLayer.isHidden = true
            lockedLayer.isHidden = false
            frozenLayer.isHidden = false
            okStakingLayer.isHidden = true
            okUnbondingLayer.isHidden = true
            
            let total = WUtils.getAllBnbToken(stakingDenom)
            let available = BaseData.instance.availableAmount(stakingDenom)
            let locked = BaseData.instance.lockedAmount(stakingDenom)
            let frozen = BaseData.instance.frozenAmount(stakingDenom)
            totalAmount.attributedText = WDP.dpAmount(total.stringValue, totalAmount.font!, stakingDivideDecimal, stakingDisplayDecimal)
            availableAmount.attributedText = WDP.dpAmount(available.stringValue, availableAmount.font, stakingDivideDecimal, stakingDisplayDecimal)
            lockedAmount.attributedText = WDP.dpAmount(locked.stringValue, lockedAmount.font, stakingDivideDecimal, stakingDisplayDecimal)
            frozenAmount.attributedText = WDP.dpAmount(frozen.stringValue, frozenAmount.font, stakingDivideDecimal, stakingDisplayDecimal)
            
        } else if (chainType == ChainType.OKEX_MAIN) {
            vestingLayer.isHidden = true
            delegatedLayer.isHidden = true
            unbondingLayer.isHidden = true
            rewardLayer.isHidden = true
            lockedLayer.isHidden = true
            frozenLayer.isHidden = true
            okStakingLayer.isHidden = false
            okUnbondingLayer.isHidden = false
            
            let total = WUtils.getAllExToken(stakingDenom)
            let available = BaseData.instance.availableAmount(stakingDenom)
            let locked = BaseData.instance.lockedAmount(stakingDenom)
            let deposit = BaseData.instance.okDepositAmount()
            let withdraw = BaseData.instance.okWithdrawAmount()
            totalAmount.attributedText = WDP.dpAmount(total.stringValue, totalAmount.font!, stakingDivideDecimal, stakingDisplayDecimal)
            availableAmount.attributedText = WDP.dpAmount(available.stringValue, availableAmount.font, stakingDivideDecimal, stakingDisplayDecimal)
            lockedAmount.attributedText = WDP.dpAmount(locked.stringValue, lockedAmount.font, stakingDivideDecimal, stakingDisplayDecimal)
            okStakingAmount.attributedText = WDP.dpAmount(deposit.stringValue, okStakingAmount.font, stakingDivideDecimal, stakingDisplayDecimal)
            okUnbondingAmount.attributedText = WDP.dpAmount(withdraw.stringValue, okUnbondingAmount.font, stakingDivideDecimal, stakingDisplayDecimal)
            
        }
        cardRoot.backgroundColor = chainConfig?.chainColorBG
    }
}
